import { isEmpty } from "@ember/utils"

const accentMap = {
  àáâãäå: 'a',
  æ: 'e',
  èéêë: 'e',
  ìíîï: 'i',
  ç: 'c',
  òóôõö: 'o',
  ùúûü: 'u',
  ýÿ: 'y'
}

export default function strip(term) {
  if (isEmpty(term)) {
    return ""
  }

  let modifiedTerm = term
  let pattern = /[^A-Za-z0-9? ]/g

  Object.keys(accentMap).forEach(item => {
    let pattern = new RegExp(`[${item}]`, 'g')
    modifiedTerm = modifiedTerm.replace(pattern, accentMap[item])
  })

  return modifiedTerm.replace(pattern, "")
}
